View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.codec;
    21
    22  import java.nio.ByteBuffer;
    23
    24  /**
    25   * In charge of encoding a message of type MESSAGE into another form (could be a {@link ByteBuffer} or any other
    26   * protocol level construction.
    27   *
    28   * Must be immutable, a CONTEXT will be provided per session.
    29   *
    30   * @param <INPUT> the incoming message to encode (your high level protocol Pojo/DTO)
    31   * @param <OUTPUT> the encoded message (the low level message, usually a {@link ByteBuffer})
    32   * @param <ENCODING_STATE> the context where to save the current encoding state (e.g. encoding context switching..)
    33   *
    34   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    35   *
    36   */
    37  public interface ProtocolEncoder<INPUT /* message type */, OUTPUT, ENCODING_STATE> {
    38
    39      /**
    40       * Create a new session context for this decoder
    41       *
    42       * @return the newly created context
    43       */
    44      ENCODING_STATE createEncoderState();
    45
    46      /**
    47       * Encodes higher-level message objects of type <code>INPUT</code> into binary or protocol-specific data of type
    48       * <code>OUTPUT</code>.
    49       *
    50       * @param message the message to encode
    51       * @param context the encoding context (will be stored in the session for the next decode call)
    52       */
    53      OUTPUT encode(INPUT message, ENCODING_STATE context);
    54
    55  }